package apis

import (
    "fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineAccountSetting struct {
	api.Api
}

// GetPage 获取登录账户管理列表
// @Summary 获取登录账户管理列表
// @Description 获取登录账户管理列表
// @Tags 登录账户管理
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineAccountSetting}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-account-setting [get]
// @Security Bearer
func (e LineAccountSetting) GetPage(c *gin.Context) {
    req := dto.LineAccountSettingGetPageReq{}
    s := service.LineAccountSetting{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
   	if err != nil {
   		e.Logger.Error(err)
   		e.Error(500, err, err.Error())
   		return
   	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineAccountSetting, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取登录账户管理失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取登录账户管理
// @Summary 获取登录账户管理
// @Description 获取登录账户管理
// @Tags 登录账户管理
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineAccountSetting} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-account-setting/{id} [get]
// @Security Bearer
func (e LineAccountSetting) Get(c *gin.Context) {
	req := dto.LineAccountSettingGetReq{}
	s := service.LineAccountSetting{}
    err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineAccountSetting

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取登录账户管理失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK( object, "查询成功")
}

// Insert 创建登录账户管理
// @Summary 创建登录账户管理
// @Description 创建登录账户管理
// @Tags 登录账户管理
// @Accept application/json
// @Product application/json
// @Param data body dto.LineAccountSettingInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-account-setting [post]
// @Security Bearer
func (e LineAccountSetting) Insert(c *gin.Context) {
    req := dto.LineAccountSettingInsertReq{}
    s := service.LineAccountSetting{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建登录账户管理失败，\r\n失败信息 %s", err.Error()))
        return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改登录账户管理
// @Summary 修改登录账户管理
// @Description 修改登录账户管理
// @Tags 登录账户管理
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineAccountSettingUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-account-setting/{id} [put]
// @Security Bearer
func (e LineAccountSetting) Update(c *gin.Context) {
    req := dto.LineAccountSettingUpdateReq{}
    s := service.LineAccountSetting{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改登录账户管理失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "修改成功")
}

// Delete 删除登录账户管理
// @Summary 删除登录账户管理
// @Description 删除登录账户管理
// @Tags 登录账户管理
// @Param data body dto.LineAccountSettingDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-account-setting [delete]
// @Security Bearer
func (e LineAccountSetting) Delete(c *gin.Context) {
    s := service.LineAccountSetting{}
    req := dto.LineAccountSettingDeleteReq{}
    err := e.MakeContext(c).
        MakeOrm().
        Bind(&req).
        MakeService(&s.Service).
        Errors
    if err != nil {
        e.Logger.Error(err)
        e.Error(500, err, err.Error())
        return
    }

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除登录账户管理失败，\r\n失败信息 %s", err.Error()))
        return
	}
	e.OK( req.GetId(), "删除成功")
}
